function kMeansDemo1(dataset)

% ------------------------ parameters section -------------------------------
if nargin<1
        dataset = './data/blobs01.mat';
end

interactive = 1;

% ------------------------ here be the code ---------------------------------
% load dataset - also try with other .mat files (e.g. circles02.mat, ...)
load(dataset);

fprintf('I have loaded dataset %s\n',dataset);
fprintf('Dataset characteristics: %d points, %d-dimensional space, %d clusters\n\n',size(X,1),size(X,2),clusters);
% plot data
fprintf('Plotting data...\n');
figure;plotClustering(X,classes,classes);drawnow();
title('Data plot (colors/shapes represent different classes)')
if (interactive) fprintf('Press a key to continue.\n\n'); pause; end

% run kmeans three times...
maxiter = 3;
for i = 1 : maxiter
	fprintf('Running k-means (%02d/%02d)\n',i,maxiter);
	[centroid, pointsInCluster, labelsKM]= myKmeans(X, clusters);
	figure;plotClustering(X,labelsKM,classes);
	title(sprintf('Results of k-means (k=%d) ran on the original data space. Accuracy: %.4f',clusters,accuracy(labelsKM,classes)));
	if (interactive) fprintf('Press a key to continue.\n\n'); pause; end
end

fprintf('Were the results the same?\n\n');

end
