function kMeansDemo3(dataset)

% ------------------------ parameters section -------------------------------
if nargin<1
        dataset = './data/blobs01.mat';
end

interactive = 1;

% ------------------------ here be the code ---------------------------------
% load dataset - also try with other .mat files (e.g. circles02.mat, ...)
load(dataset);

fprintf('I have loaded dataset %s\n',dataset);
fprintf('Dataset characteristics: %d points, %d-dimensional space, %d clusters\n\n',size(X,1),size(X,2),clusters);
% plot data
fprintf('Plotting data...\n');
figure;plotClustering(X,classes,classes);drawnow();
title('Data plot (colors/shapes represent different classes)')
fprintf('Now, suppose we do not know the number of clusters in advance,\n');
fprintf('and try to estimate it by looking at how SSE changes.\n\n');
fprintf('We will run k-means for k varying between 2 to 10. To have\n');
fprintf('stabler results, for every k we will run k-means 10 times\n');
fprintf('and take the lowest SSE.\n\n');
fprintf('So, k-means will run 9*10=90 times, this might take a while...\n\n');
if (interactive) fprintf('Press a key to continue.\n\n'); pause; end

for i = 2 : 10
	[labels(:,i),centroids,sse(i)]=repKmeans(X,i,10);
end

figure;plot(2:10,sse(2:10));
title('Value of SSE as a function of k in k-means algorithm');

fprintf('Can you spot the "elbow" in the plot, that is the point\n');
fprintf('where SSE stops decreasing as much as it did before?\n\n');

k = input('Now enter the number of clusters of this dataset (2~10): ');

while k ~= 0
	fprintf('Here is the result of k-means with k=%d...\n',k);

	figure;plotClustering(X,labels(:,k),classes);
	title(sprintf('Results of k-means (k=%d). Accuracy: %.4f',k,accuracy(labels(:,k),classes)));
	fprintf('Was the result satisfying? Do you want to see how it changes\n');
	fprintf('with k? Feel free to try different values of k (between 2 \n');
	fprintf('and 10), then enter 0 when you are done.\n\n');
	k = input('Enter the number of clusters of this dataset: ');
end	

end
